import { ACTIONS } from './actions.js';
import deepDiff from 'deep-diff';
import rfdc from 'rfdc';
import { broadcast, send } from './clients.js';
const deepClone = rfdc();
let current = {};
let clone = deepClone(current);
export function state() {
    return clone;
}
export function init(state) {
    current = deepClone(state);
    clone = deepClone(current);
    broadcast(ACTIONS.STATE_INIT, current);
}
export function initState(id) {
    send(id, ACTIONS.STATE_INIT, state());
}
function compressKeys(diff) {
    const result = { k: diff.kind };
    if (diff.hasOwnProperty('path'))
        result.p = diff.path;
    if (diff.hasOwnProperty('lhs'))
        result.l = diff.lhs;
    if (diff.hasOwnProperty('rhs'))
        result.r = diff.rhs;
    if (diff.hasOwnProperty('index'))
        result.x = diff.index;
    if (diff.hasOwnProperty('item'))
        result.i = diff.item;
    return result;
}
export function update(state) {
    const diffs = deepDiff.diff(current, state);
    if (diffs && diffs.length > 0) {
        diffs.map(d => deepDiff.applyChange(current, state, d));
        broadcast(ACTIONS.STATE_UPDATE, diffs.map(compressKeys));
        clone = deepClone(current);
    }
}
